/*
 *
 * Utility for drawing a tinyGL exported OpenGL model
 *
 */

#include <math.h>

#include "tinyGLU.h"

static void cross(GLfloat *v1, GLfloat *v2, GLfloat *v3, GLfloat *o) {
  float l;
  o[0] = (v1[1]-v3[1])*(v2[2]-v3[2]) - (v1[2]-v3[2])*(v2[1]-v3[1]);
  o[1] = (v1[2]-v3[2])*(v2[0]-v3[0]) - (v1[0]-v3[0])*(v2[2]-v3[2]);
  o[2] = (v1[0]-v3[0])*(v2[1]-v3[1]) - (v1[1]-v3[1])*(v2[0]-v3[0]);
  l = sqrt(o[0]*o[0]+o[1]*o[1]+o[2]*o[2]);
  o[0] /= l;
  o[1] /= l;
  o[2] /= l;
}

void tglDrawModel(GLfloat *vertexes, GLint *indexes) {
  int i=0;
  glDisable(GL_CULL_FACE);
  glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,1);
  glShadeModel(GL_FLAT);
  while (indexes[i]>=0) {
    float n[3];
    glBegin(GL_TRIANGLES);
    while (indexes[i]>=0) {
      if (indexes[i+1]>=0 &&
	  indexes[i+2]>=0) {
	cross(&vertexes[indexes[i]*3],
	      &vertexes[indexes[i+1]*3],
	      &vertexes[indexes[i+2]*3],
	      n);
	glNormal3fv(n);
	glVertex3fv(&vertexes[indexes[i]*3]);
	glVertex3fv(&vertexes[indexes[i+1]*3]);
	glVertex3fv(&vertexes[indexes[i+2]*3]);
      }
      i++;
    }
    glEnd();
    i++;
  }
}

